#define RRRTYPE 0
#define RRITYPE 1
#define RITYPE  2
#define RRETYPE 3

void split_instruction(unsigned short instruction,short *opcode,
		       short *arg1, short *arg2, short *arg3, short *arg4);
void decode_assembly(short assembly,short pc,char *return_string);

#define OP_SHIFT 13
#define A_SHIFT  10
#define B_SHIFT   7
#define EXT_SHIFT 4

#define ADD  0
#define ADDI 1
#define NAND 2
#define LUI  3
#define SW   4
#define LW   5
#define BEQ  6
#define JALR 7
#define EXT  7	/* EXTENDED overlapped with JALR */
/* extended opcodes */
#define EXC  8
#define SYS  9
/* define pseudo-ops */
#define NOP   10
#define HALT  11
#define LLI   12
#define MOVI  13
/* define directives */
#define FILL  14
#define SPACE 15
#define INCLUDE 16
#define EQU     17
#define BYTE    18
#define ASCII   19
/* invalid */
#define INVALID -1

/* extended instructions */
#define EXT_EXCEPTION 0
#define EXT_SYSCALL   1

/* exception types */
#define EXC_HALT      0
#define EXC_DEBUG     1

int get_opcode(char *string);

